(*
	=====================================================================
    @\gŃtH[
	---------------------------------------------------------------------
		1.GNXv[̃hbOAhhbvΉ
        	1.St@CStringListɏ㏑ۑ
         	2.StH_StringListɏ㏑ۑ
            3.ʒu擾
            4.̈ʒuɂRg[ւ̎QƂ擾
            5.hbOAhhbvNΉ
	---------------------------------------------------------------------
		2.ʒu̍Č
        	1.NINIt@Cǂݍ
            2.IINIt@Cɏ
	---------------------------------------------------------------------
		3.Init@C
            1.string̏/ǂݍ
            2.Bool^̏/ǂݍ
	---------------------------------------------------------------------
		4.AvP[V
        	1.[Esc]ɂI
			2.dNh~
			3.ċN
	=====================================================================

	=====================================================================
	t@C֐
	---------------------------------------------------------------------
		1.pXǂ`FbN
        2.t@Cǂݍ
	=====================================================================
*)
unit Base;

interface

uses
    Windows, Messages, SysUtils, Classes, Controls, Forms,
    Dialogs, ShellApi, IniFiles;

type
    TBaseForm = class(TForm)
        procedure FormCreate(Sender: TObject);
        procedure FormDestroy(Sender: TObject);
        procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    private
        { Private 錾 }
        procedure	LoadPosition();
        procedure	SavePosition();
		procedure	ParamDrops();
	    procedure	WMDropFiles(var Msg: TWMDROPFILES); message WM_DROPFILES;
    public
        { Public 錾 }
    protected
    	EscapeClose: Boolean;
    	DropFileList: TStringList;
    	DropFoldList: TStringList;
        DropPos: TPoint;
        DropControl: TControl;
        AppIni: TIniFile;
        procedure	DroppedAction(); virtual; abstract;
		procedure	UpdateDropList(AFileName: string);
		procedure	SaveIniString(AName, AValue: string);
		function	LoadIniString(AName: string; ADefault: string = 'Name'): string;
		procedure	SaveIniBoolean(AName: string; AValue: Boolean);
		function	LoadIniBoolean(AName: string; ADefault: Boolean = false): Boolean;
		procedure	SaveIniInteger(AName: string; AValue: integer);
		function	LoadIniInteger(AName: string; ADefault: integer = 0): integer;
    end;

procedure   LoadFromFile(APath: string; AStrings: TStrings; IgnoreZeroLine: Boolean = False);
function	IsFolderPath(APath: string): Boolean;
function	ExecuteFile(FilePath: string): Boolean;

var
    BaseForm: TBaseForm;

implementation

{$R *.dfm}

(*
	=====================================================================
    RXgN^/fXgN^
	=====================================================================
*)

(* RXgN^ *)
procedure	TBaseForm.FormCreate(Sender: TObject);
begin
    //D&D֘A
    DragAcceptFiles(Handle, true);
	DropFileList	:= TStringList.Create;
	DropFoldList	:= TStringList.Create;
    DropPos			:= Point(-1, -1);
    DropControl		:= nil;
    //INIIuWFNg쐬
	AppIni := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
    //ʒu
    LoadPosition();
    //[Esc]Ȉ
    Self.KeyPreview := True;
    //̑
    Self.Caption := Application.Title;
end;

(* fXgN^ *)
procedure	TBaseForm.FormDestroy(Sender: TObject);
begin
	//ʒuۑ
	SavePosition();
	//INIt@Cpj
	AppIni.Free;
	//pXۑpXgj
    DropFileList.Free;
    DropFoldList.Free;
	//t@Chbv
    DragAcceptFiles(Handle, False);
end;

(*
	=====================================================================
    hbOAhhbvΉR[h
	=====================================================================
*)

(* hbvt@CXgXV *)
procedure	TBaseForm.UpdateDropList(AFileName: string);
begin
    try
        if IsFolderPath(AFileName) then
        begin
            DropFoldList.Add(AFileName);
        end
        else
        begin
            DropFileList.Add(AFileName);
        end;
    except
        ;	//
    end;
end;

(* t@ChbvɂN *)
procedure	TBaseForm.ParamDrops();
var
    i: integer;
begin
    DropFileList.Clear;
    DropFoldList.Clear;
	for i := 1 to ParamCount do
    begin
		UpdateDropList(ParamStr(i));
    end;
	DroppedAction();
end;

(* VF̃hbv *)
procedure	TBaseForm.WMDropFiles(var Msg: TWMDropFiles);
var
    i         : integer;
    FileName  : array [0..255]  of  char;
    FileCount : integer;
begin
    //hbvʒu
    DragQueryPoint(Msg.Drop, DropPos);
	//hbvʒũRg[
    DropControl := FindDragTarget(ClientToScreen(DropPos), False);
	//hbvt@C
    FileCount := DragQueryFile(Msg.Drop, $FFFFFFFF, FileName, SizeOf(FileName));
    //Xg쐬
    DropFileList.Clear;
    DropFoldList.Clear;
    for i := 0 to FileCount - 1 do begin
        DragQueryFile(Msg.Drop, i, FileName, SizeOf(FileName));
		UpdateDropList(FileName);
    end;
    DragFinish(Msg.Drop);
	DroppedAction();
end;

procedure TBaseForm.FormShow(Sender: TObject);
begin
	//hbvN̏
    ParamDrops();
end;

(*
	=====================================================================
    ʒuČ
	=====================================================================
*)

(* ʒuǍ *)
procedure	TBaseForm.LoadPosition();
begin
	Self.Top	:= LoadIniInteger('Top'			, Self.Top);
	Self.Left	:= LoadIniInteger('Left'		, Self.Left);
	Self.Width	:= LoadIniInteger('Width'		, Self.Width);
	Self.Height	:= LoadIniInteger('Height'		, Self.Height);
    EscapeClose	:= LoadIniBoolean('EscapeClose'	, EscapeClose);
end;

(* ʒuۑ *)
procedure	TBaseForm.SavePosition();
begin
	SaveIniInteger('Top'		, Self.Top);
	SaveIniInteger('Left'		, Self.Left);
	SaveIniInteger('Width'		, Self.Width);
	SaveIniInteger('Height'		, Self.Height);
    SaveIniBoolean('EscapeClose', EscapeClose);
end;

(*
	=====================================================================
    AvP[V֌W
	=====================================================================
*)

(* [Esc]I *)
procedure	TBaseForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
	if EscapeClose and (Key = VK_ESCAPE) then
    begin
    	Self.Close;
    end;
end;

(*
	=====================================================================
    INIt@C
	=====================================================================
*)

(* ۑ *)
procedure	TBaseForm.SaveIniString(AName, AValue: string);
begin
	try
		AppIni.WriteString(Self.ClassName, AName, AValue);
    except
    	;
	end;
end;

(* ǂݍ *)
function	TBaseForm.LoadIniString(AName: string; ADefault: string = 'Name'): string;
begin
	try
		Result := AppIni.ReadString(Self.ClassName, AName, ADefault);
    except
    	Result := ADefault;
	end;
end;

(* _^ۑ *)
procedure	TBaseForm.SaveIniBoolean(AName: string; AValue: Boolean);
begin
	try
		AppIni.WriteBool(Self.ClassName, AName, AValue);
    except
    	;
	end;
end;

(* _^ǂݍ *)
function	TBaseForm.LoadIniBoolean(AName: string; ADefault: Boolean = false): Boolean;
begin
	try
		Result := AppIni.ReadBool(Self.ClassName, AName, ADefault);
    except
    	Result := ADefault;
	end;
end;

(* l^ۑ *)
procedure	TBaseForm.SaveIniInteger(AName: string; AValue: integer);
begin
	try
		AppIni.WriteInteger(Self.ClassName, AName, AValue);
    except
    	;
	end;
end;

(* l^ǂݍ *)
function	TBaseForm.LoadIniInteger(AName: string; ADefault: integer = 0): integer;
begin
	try
		Result := AppIni.ReadInteger(Self.ClassName, AName, ADefault);
    except
    	Result := ADefault;
	end;
end;

(*
	=====================================================================
	t@C֐
	=====================================================================
*)

(* pXtH_t@C𒲂ׂ *)
function IsFolderPath(APath: string): Boolean;
var
	res: Boolean;
begin
	Result := False;
    res := DirectoryExists(APath);
    if res then
    begin
    	Result := True;
    end else
    begin
		res := FileExists(APath);
        if (not res) then
        begin
			raise Exception.Create('is not path');
        end;
    end;
end;

(* t@C̓ǂݍ *)
procedure   LoadFromFile(APath: string; AStrings: TStrings; IgnoreZeroLine: Boolean = False);
var
    F: TextFile;
    S: string;
begin
    AStrings.Clear;
	AssignFile(F, APath);
    Reset(F);
    while not EOF(F) do begin
        Readln(F, S);
        if IgnoreZeroLine and (Length(Trim(S)) = 0) then Continue;
        AStrings.Add(S);
    end;
    CloseFile(F);
end;

(*	ShellExecutẽbp[֐	*)
function ExecuteFile(FilePath: string): Boolean;
const
    ERROR_NO = 32;
var
    Value: integer;
begin
    Value := ShellExecute(
                    Application.MainForm.handle,
                    'open',
                    PChar(FilePath),
                    '',
                    PChar(ExtractFilePath(Application.Exename)),
                    SW_SHOWDEFAULT
                    );
    Result := (Value > ERROR_NO);
end;

end.
